#include "events_h"
#include "wrappers_h"
#include "utility_h"
#include "core_h"
#include "sys_rewards_h"
#include "sys_ambient_h"
#include "plt_desertday"

const int EVENT_TYPE_GENERIC = 70000;

void main()
{
    object oPC = GetHero();
    event ev = GetCurrentEvent();
    int nEventType = GetEventType(ev);
    switch(nEventType)
    {
        case EVENT_TYPE_AREALOAD_POSTLOADEXIT:
        {
             if (!GetLocalInt(GetModule(),"PARTY_ADDED"))
             {
                 CS_LoadCutscene(R"open_cutscene.cut");
                 SetLocalInt(GetModule(),"PARTY_ADDED",1);
                 RewardXPParty(23799);
                 //Add Hurlock PC
                 object oLeader = UT_GetNearestCreatureByTag(oPC,"emissarypc");
                 WR_SetFollowerState(oLeader, FOLLOWER_STATE_ACTIVE);
                 SetPartyLeader(oLeader);
                 //Remove old PC
                 WR_SetFollowerState(oPC, FOLLOWER_STATE_INVALID);
                 SetObjectActive(oPC, 0);
                 Safe_Destroy_Object(oPC,0);
                 //Add party members
                 object oAlpha = UT_GetNearestCreatureByTag(oLeader,"alphapc");
                 WR_SetFollowerState(oAlpha, FOLLOWER_STATE_ACTIVE);
                 object oReaver = UT_GetNearestCreatureByTag(oLeader,"hurlockpc");
                 WR_SetFollowerState(oReaver, FOLLOWER_STATE_ACTIVE);
                 object oGenlock = UT_GetNearestCreatureByTag(oLeader,"genlockpc");
                 WR_SetFollowerState(oGenlock, FOLLOWER_STATE_ACTIVE);
                 event tactload = Event(EVENT_TYPE_GENERIC);
                 DelayEvent(0.1,oAlpha,tactload,"hire_alpha");
                 DelayEvent(0.1,oLeader,tactload,"hire_emissary");
                 DelayEvent(0.1,oReaver,tactload,"hire_hurlock");
                 DelayEvent(0.1,oGenlock,tactload,"hire_genlock");
                 UT_TeamGoesHostile(1,FALSE);
                 UT_TeamGoesHostile(2,FALSE);
                 UT_TeamGoesHostile(3,FALSE);
                 UT_TeamGoesHostile(5,FALSE);
             }
             break;
         }
        case EVENT_TYPE_TEAM_DESTROYED:
        {
            int team_dest = GetEventInteger(ev,0);
            if (team_dest == 3)
            {
                SetLocalInt(GetModule(),"MAGE_DEAD",1);
            }
        }
        case EVENT_TYPE_GAMEMODE_CHANGE:
        {       
            if (GetLocalInt(GetModule(),"MAGE_DEAD"))
            {                                       
                object oAlpha = GetObjectByTag("alphapc");
                SetCurrentHealth(oAlpha,100.0);
                event transition = Event(EVENT_TYPE_GENERIC);
                DelayEvent(5.0,oAlpha,transition,"area_desert");
            }
        } 
        case EVENT_TYPE_GENERIC:
        {
            if (GetLocalInt(GetModule(),"MAGE_DEAD"))
            {
                object oAlpha = GetObjectByTag("alphapc");
                WR_SetFollowerState(oAlpha,FOLLOWER_STATE_INVALID);
                SetPlotGiver(oAlpha,TRUE);
                ClearAllCommands(oAlpha);
                SetCombatState(oAlpha,FALSE);
                WR_SetPlotFlag(PLT_DESERTDAY,DESERT_COMPLETE,TRUE); 
            } 
        }
    }
    HandleEvent(ev, RESOURCE_SCRIPT_AREA_CORE);
}
