#include "events_h"
#include "wrappers_h"
#include "utility_h"
#include "core_h"
#include "sys_ambient_h"

void main()
{
    event ev = GetCurrentEvent();
    int nEventType = GetEventType(ev);
    switch(nEventType)
    {
        case EVENT_TYPE_AREALOAD_PRELOADEXIT:
        {
             if (!GetLocalInt(GetModule(),"NIGHT_LOADED"))
             {
                 SetLocalInt(GetModule(),"NIGHT_LOADED",1);
                 UT_TeamGoesHostile(1,FALSE);
                 Injury_RemoveAllInjuriesFromParty();
                 object oEmissary = GetObjectByTag("emissarypc");
                 object oHurlock = GetObjectByTag("hurlockpc");
                 object oGenlock = GetObjectByTag("genlockpc");
                 Effects_RemoveAllEffects(oEmissary,TRUE,TRUE);
                 Effects_RemoveAllEffects(oHurlock,TRUE,TRUE);
                 Effects_RemoveAllEffects(oGenlock,TRUE,TRUE);
                 HealPartyMembers(TRUE,TRUE);
                 SetCooldown(oEmissary,14000,0.0);
                 SetCooldown(oEmissary,13001,0.0);
                 SetCooldown(oEmissary,15002,0.0);
                 SetCooldown(oEmissary,12008,0.0);
                 SetCooldown(oEmissary,11101,0.0);
                 SetCooldown(oEmissary,10700,0.0);
                 SetCooldown(oEmissary,10701,0.0);
                 SetCooldown(oGenlock,603,0.0);
                 SetCooldown(oGenlock,3035,0.0);
                 SetCooldown(oGenlock,10,0.0);
                 SetCooldown(oGenlock,7,0.0);
                 SetCooldown(oGenlock,3072,0.0);
                 SetCooldown(oGenlock,804,0.0);
                 SetCooldown(oGenlock,3060,0.0);
                 SetCooldown(oGenlock,2023,0.0);
                 SetCooldown(oHurlock,617,0.0);
                 SetCooldown(oHurlock,38,0.0);
                 SetCooldown(oHurlock,3066,0.0);
                 SetCooldown(oHurlock,4016,0.0);
                 SetCooldown(oHurlock,3009,0.0);
                 SetCooldown(oHurlock,3065,0.0);
                 SetCooldown(oHurlock,3067,0.0);
                 SetCooldown(oHurlock,713,0.0);
             }
             break;
        }
        case EVENT_TYPE_AREALOAD_POSTLOADEXIT:
        {
             CS_LoadCutscene(R"transition.cut");
            //CS_LoadCutscene(R"end_cutscene.cut");
        }
        case EVENT_TYPE_TEAM_DESTROYED:
        {
            int teamdest = GetEventInteger(ev,0);
            if (teamdest == 1)
            {
                ResurrectPartyMembers(TRUE);
                SetLocalInt(GetModule(),"DARKSPAWN_DEAD",1);
                Safe_Destroy_Object(GetObjectByTag("amb_ext_medfire_lp"));
                Safe_Destroy_Object(GetObjectByTag("dark_mirror_vfx"));
                Safe_Destroy_Object(GetObjectByTag("darkspawn_emitter"));
                Safe_Destroy_Object(GetObjectByTag("amb_ext_waterlap_lp"));
            }
            else if (teamdest == 4)
            {
                ResurrectPartyMembers(TRUE);
                int j;
                for (j = 1; j < 5; j++)
                {
                    object[] currentTeam = UT_GetTeam(j);
                    int i;
                    for (i = 0; i < GetArraySize(currentTeam); i++)
                    {
                        SetObjectActive(currentTeam[i],FALSE);
                    }
                }
                CS_LoadCutscene(R"end_cutscene.cut");
            }
        }
        case EVENT_TYPE_GAMEMODE_CHANGE:
        {
            if (GetLocalInt(GetModule(),"DARKSPAWN_DEAD")
                && !GetLocalInt(GetModule(),"WARDEN_START"))
            {
                ResurrectPartyMembers(TRUE);
                SetLocalInt(GetModule(),"WARDEN_START",1);
                object oEmissary = GetObjectByTag("emissarypc");
                object oHurlock = GetObjectByTag("hurlockpc");
                object[] allies = UT_GetTeam(2);
                int i;
                for (i = 0; i < GetArraySize(allies); i++)
                {
                    KillCreature(allies[i]);
                }
                SetObjectActive(GetObjectByTag("hurlock_alpha"),FALSE);
                CS_LoadCutscene(R"alpha_dies.cut");
                //UT_Talk(oHurlock,oEmissary,R"wardens_arrive.dlg");
            }
        }
   }
        HandleEvent(ev, RESOURCE_SCRIPT_AREA_CORE);
}